//NANO 168 or 328

//const float t = 0.0048828125; = 5v / 1024 разряда ацп
//D0 кнопка ВЫКЛ
//D1 ON/OFF транзистор
//D2 INT0 прерывание(кз - перегрузка)
//D3 BTN кнопка
//D4 SOUND +
//D5 SOUND -
//D6 вкл/выкл выходное напряжение

//      LCD5110
//      SCK  - Pin 8
//      MOSI - Pin 10
//      DC   - Pin 11
//      RST  - Pin 13
//      CS   - Pin 12

#include <LCD5110_Graph.h>
LCD5110 myGLCD(8,10,11,13,12);
extern uint8_t SmallFont[];
extern uint8_t logo0[];
extern uint8_t logo1[];
extern uint8_t logo2[];
extern uint8_t logo[];

int ra=7;        //вход ацп - установка тока защиты
int inv=6;       //вход ацп - выходное напряжение
int ina=5;       //вход ацп - ток нагрузки
int outa=9;      //выход шим - установка тока срабатывания защиты
int tmpa = 2000; //что-бы > 1023
float tmp;
volatile byte kz=0; //флаг короткого или перегрузки по току
byte trimm = 0;     //надо для сигнала кз или перегрузки
byte q, triger = 0;//q = помигать картинкой с ладошкой, triger = вкл/выкл выходное напряжение
int timer = 6000;  //примерно 5 мин до откл если нет тока нагрузки

void interrupt(){  //прерывание 0
  for (unsigned int i = 0; i < 50000; i++){   //примерно 50 миллисек пауза (что-бы если конденсаторы фильтра зарядились)
    __asm__ volatile 
  (
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  "nop\n\t"
  );
  }
//*****************************  
   if (digitalRead(2) == 0){ //если после паузы 0 на пин 2
     digitalWrite(6, 0);    //выходное напр выкл
     kz=1;                   //поставить флаг КЗ
    }
   }
////////////////////////////////////////////////
void off(){  //выключение
    detachInterrupt(0);   //выкл прерывание
    digitalWrite(6, 0);  //выкл выходное напряжение
    myGLCD.invert(false);
    myGLCD.clrScr();
    myGLCD.print("***GOODBYE***",CENTER ,20);
     myGLCD.drawRoundRect(0, 0, 83, 47);
     myGLCD.drawRoundRect(2, 2, 83-2, 47-2);
     myGLCD.update();
     delay(4000);
     tone(4, 740, 500);
     delay(500);
     tone(4, 440, 500);
     delay(500);
ll:  digitalWrite (1,0);  //сетевое реле откл
    goto ll;      //и зациклить
}
   
void setup() {
    pinMode(6, OUTPUT);
    digitalWrite (6,0);  //выходное напр выкл
    pinMode(1, OUTPUT);
    digitalWrite (1,1);  //включился (сетевое реле вкл)

  pinMode(0, INPUT_PULLUP);        
  pinMode(2, INPUT); 
  pinMode(3, INPUT_PULLUP);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);              

  myGLCD.InitLCD();
  myGLCD.setFont(SmallFont);
  myGLCD.invert(true);
  
  myGLCD.clrScr();
  
  for (int f= 0; f < 30; f =f+1){  //примерно 5 сек крутим заставку
  if (digitalRead(0)==0) off();  //если нужно выключить
  
  myGLCD.drawBitmap(0, 0, logo0, 84, 48);
  myGLCD.update();
  delay (30);
  myGLCD.drawBitmap(0, 0, logo1, 84, 48);
  myGLCD.update();
  delay (30);
  myGLCD.drawBitmap(0, 0, logo2, 84, 48);
  myGLCD.update();
  delay (30);
 }
 myGLCD.invert(false);
 
 TCCR1B = TCCR1B & 0b11111000 | 0x02;// 9, 10 пин, частота шим 3906,25 гц
 tmpa=analogRead(ra);        //в tmpa  начальная установка тока защиты
 analogWrite(outa, tmpa/4); //поставить ток защиты
  
 myGLCD.clrScr();
 myGLCD.print("Power Box !",CENTER ,15);
 myGLCD.print("ver 1,0,2 OK.",CENTER ,25);
 myGLCD.drawRoundRect(0, 0, 83, 47);
 myGLCD.drawRoundRect(2, 2, 83-2, 47-2);
 myGLCD.update();
          delay (2000);
  digitalWrite (6,1);
          delay (50);
  attachInterrupt(0, interrupt,FALLING); //прерывания вкл
}

void loop() {  // и основной цикл
  if (digitalRead(0) == 0) off(); //если нажата кнопка OFF то выключить
   if (kz == 1){                  //если флаг короткого = 1, (он устанавливается в прерывании) то.....
   detachInterrupt(0);            //выкл прерывания
   digitalWrite(6, 0);            //выкл выходное напряжение

            myGLCD.clrScr();
            myGLCD.drawBitmap(0, 0, logo, 84, 48); //картинка с ладонью
            myGLCD.update();
lop:
   if (digitalRead(0) == 0) off();    //если нажата кнопка OFF то выключить
   if (digitalRead(3) == 1){          //если не нажата кнопка BTN
     
     if (q ==0){      //помигать картинкой с ладошкой
       myGLCD.invert(false);
       q=1;
     }else{
       myGLCD.invert(true);
       q=0;
     }

    for (float f= 0; f<180; f=f + 0.35){  //0.32 ~ 0.35 это примерно полицейская сиренка wail speed signal, 0.04  полицейская сиренка wail nospeed
    float g=f*3.141593/180;        //из градусов в радианы
    float z=(1-sin(g))*1400+160;//------2800+1000..........? ХозЯин Барин (верхний и нижний тон сирены)
    int pz=int(z);
    
    delayMicroseconds(pz);
    if (trimm==0){        //импульс на SOUND+
     PORTD = PORTD | 16;  //D4 digitalWrite(4, 1);
     delayMicroseconds(220);
     PORTD = PORTD ^ 16;  //D4 digitalWrite(4, 0);
     trimm=1;
    }else{                //импульс на SOUND-
      PORTD = PORTD | 32; //D5 digitalWrite(5, 1);
      delayMicroseconds(220);
     PORTD = PORTD ^ 32;  //D5 digitalWrite(5, 0);
     trimm=0;
    }
  }
     goto lop;
   }
   else{        //если нажата кнопка BTN
mmm:  if(digitalRead(3)==0) goto mmm; //подождать когда отпустят кнопку
   }
   kz=0;    //обнулить флаг короткого
   if (triger == 0){ //экранчик после мигания в предыдущее состояние
    myGLCD.invert(false);
   }
   else{
    myGLCD.invert(true);
   }
   digitalWrite(6, 1); //вкл выходное напряжение
   delay(50);
   attachInterrupt(0, interrupt,FALLING);  //вкл прерывания
  }
  ///////////////////////////////////////////  кнопка BTN - вкл/откл выходное напр
     if(digitalRead(3)==0){          //если нажата....
nnn: if(digitalRead(3)==0) goto nnn; //ждать когда отпустят
     if(triger == 0){          //выкл выходное напряжение
      detachInterrupt(0);
      triger = 1;
      myGLCD.invert(true);
      tone(4, 1000, 300);      //пик...
      delay(300);
      digitalWrite(6, 0);
    }
      else{          //вкл выходное напряжение
      triger = 0;
      myGLCD.invert(false);
      tone(4, 1000, 300);      //пик...
      delay(300);
      digitalWrite(6, 1);
      delay(50);
      attachInterrupt(0, interrupt,FALLING);
     }       
    }
  ////////////////////////////////////////////
  int a=analogRead(ra);    //читать состояние резистора установки тока защиты
  if (a != tmpa && kz == 0){//если отличается от предыдущего и флаг короткого (перегрузки) = 0......
    tmpa=a;
    analogWrite(outa, tmpa/4);//вывести новое значение скважности шим (это регулировка напр от почти 0в до 5в на к554са3а)
  }                     
//отрисоваться........
    myGLCD.clrScr();
//LM358N (VoltOUT) Kyc=3.2  ...выходное напр
    tmp = analogRead(inv)*0.0048828125*3.2;
    myGLCD.print("Vn(V) = ",3, 3);
    myGLCD.printNumF(tmp,2 ,51 ,3); 
    float ttt=tmp;    
//LM358N (AmperIN) Kyc=25  ...ток нагрузки
    tmp = analogRead(ina)*0.0048828125/2.5;
    myGLCD.print("In(A) = ",3,13);
    myGLCD.printNumF(tmp,2 ,51 ,13);                 
    myGLCD.print("Pn(W) = ",3,23);  //...мощность потребляемая нагрузкой
    myGLCD.printNumF(ttt * tmp,2 , 51, 23); 
    
      if (tmp < 0.01){  //если ток нагрузки меньше 10 мла, уменьшить переменную timer
      timer = timer-1;
      if (timer == 0) off();//если timer = 0 то выключить БП
      }
      else{            //если есть ток нагрузки
      timer = 6000;  //обновить переменную
      }

     myGLCD.print("Ik(A) = ", 3, 37);
     myGLCD.printNumF(a*0.0048828125/2.5, 2, 51, 37);  //...установленный ток защиты
     myGLCD.drawRoundRect(0, 0, 83, 47);
     myGLCD.update();
}
